# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.98
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class ComplianceRuleBreakdown(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'group_status': 'str',
        'results_used': 'dict(str, float)',
        'properties_used': 'dict(str, list[ModelProperty])',
        'missing_data_information': 'list[str]',
        'lineage': 'list[LineageMember]'
    }

    attribute_map = {
        'group_status': 'groupStatus',
        'results_used': 'resultsUsed',
        'properties_used': 'propertiesUsed',
        'missing_data_information': 'missingDataInformation',
        'lineage': 'lineage'
    }

    required_map = {
        'group_status': 'required',
        'results_used': 'required',
        'properties_used': 'required',
        'missing_data_information': 'required',
        'lineage': 'required'
    }

    def __init__(self, group_status=None, results_used=None, properties_used=None, missing_data_information=None, lineage=None, local_vars_configuration=None):  # noqa: E501
        """ComplianceRuleBreakdown - a model defined in OpenAPI"
        
        :param group_status:  The status of this subset of results. (required)
        :type group_status: str
        :param results_used:  Dictionary of AddressKey (as string) and their corresponding decimal values, that were used in this rule. (required)
        :type results_used: dict(str, float)
        :param properties_used:  Dictionary of PropertyKey (as string) and their corresponding Properties, that were used in this rule (required)
        :type properties_used: dict(str, list[ModelProperty])
        :param missing_data_information:  List of string information detailing data that was missing from contributions processed in this rule (required)
        :type missing_data_information: list[str]
        :param lineage:  (required)
        :type lineage: list[lusid.LineageMember]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._group_status = None
        self._results_used = None
        self._properties_used = None
        self._missing_data_information = None
        self._lineage = None
        self.discriminator = None

        self.group_status = group_status
        self.results_used = results_used
        self.properties_used = properties_used
        self.missing_data_information = missing_data_information
        self.lineage = lineage

    @property
    def group_status(self):
        """Gets the group_status of this ComplianceRuleBreakdown.  # noqa: E501

        The status of this subset of results.  # noqa: E501

        :return: The group_status of this ComplianceRuleBreakdown.  # noqa: E501
        :rtype: str
        """
        return self._group_status

    @group_status.setter
    def group_status(self, group_status):
        """Sets the group_status of this ComplianceRuleBreakdown.

        The status of this subset of results.  # noqa: E501

        :param group_status: The group_status of this ComplianceRuleBreakdown.  # noqa: E501
        :type group_status: str
        """
        if self.local_vars_configuration.client_side_validation and group_status is None:  # noqa: E501
            raise ValueError("Invalid value for `group_status`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                group_status is not None and len(group_status) < 1):
            raise ValueError("Invalid value for `group_status`, length must be greater than or equal to `1`")  # noqa: E501

        self._group_status = group_status

    @property
    def results_used(self):
        """Gets the results_used of this ComplianceRuleBreakdown.  # noqa: E501

        Dictionary of AddressKey (as string) and their corresponding decimal values, that were used in this rule.  # noqa: E501

        :return: The results_used of this ComplianceRuleBreakdown.  # noqa: E501
        :rtype: dict(str, float)
        """
        return self._results_used

    @results_used.setter
    def results_used(self, results_used):
        """Sets the results_used of this ComplianceRuleBreakdown.

        Dictionary of AddressKey (as string) and their corresponding decimal values, that were used in this rule.  # noqa: E501

        :param results_used: The results_used of this ComplianceRuleBreakdown.  # noqa: E501
        :type results_used: dict(str, float)
        """
        if self.local_vars_configuration.client_side_validation and results_used is None:  # noqa: E501
            raise ValueError("Invalid value for `results_used`, must not be `None`")  # noqa: E501

        self._results_used = results_used

    @property
    def properties_used(self):
        """Gets the properties_used of this ComplianceRuleBreakdown.  # noqa: E501

        Dictionary of PropertyKey (as string) and their corresponding Properties, that were used in this rule  # noqa: E501

        :return: The properties_used of this ComplianceRuleBreakdown.  # noqa: E501
        :rtype: dict(str, list[ModelProperty])
        """
        return self._properties_used

    @properties_used.setter
    def properties_used(self, properties_used):
        """Sets the properties_used of this ComplianceRuleBreakdown.

        Dictionary of PropertyKey (as string) and their corresponding Properties, that were used in this rule  # noqa: E501

        :param properties_used: The properties_used of this ComplianceRuleBreakdown.  # noqa: E501
        :type properties_used: dict(str, list[ModelProperty])
        """
        if self.local_vars_configuration.client_side_validation and properties_used is None:  # noqa: E501
            raise ValueError("Invalid value for `properties_used`, must not be `None`")  # noqa: E501

        self._properties_used = properties_used

    @property
    def missing_data_information(self):
        """Gets the missing_data_information of this ComplianceRuleBreakdown.  # noqa: E501

        List of string information detailing data that was missing from contributions processed in this rule  # noqa: E501

        :return: The missing_data_information of this ComplianceRuleBreakdown.  # noqa: E501
        :rtype: list[str]
        """
        return self._missing_data_information

    @missing_data_information.setter
    def missing_data_information(self, missing_data_information):
        """Sets the missing_data_information of this ComplianceRuleBreakdown.

        List of string information detailing data that was missing from contributions processed in this rule  # noqa: E501

        :param missing_data_information: The missing_data_information of this ComplianceRuleBreakdown.  # noqa: E501
        :type missing_data_information: list[str]
        """
        if self.local_vars_configuration.client_side_validation and missing_data_information is None:  # noqa: E501
            raise ValueError("Invalid value for `missing_data_information`, must not be `None`")  # noqa: E501

        self._missing_data_information = missing_data_information

    @property
    def lineage(self):
        """Gets the lineage of this ComplianceRuleBreakdown.  # noqa: E501


        :return: The lineage of this ComplianceRuleBreakdown.  # noqa: E501
        :rtype: list[lusid.LineageMember]
        """
        return self._lineage

    @lineage.setter
    def lineage(self, lineage):
        """Sets the lineage of this ComplianceRuleBreakdown.


        :param lineage: The lineage of this ComplianceRuleBreakdown.  # noqa: E501
        :type lineage: list[lusid.LineageMember]
        """
        if self.local_vars_configuration.client_side_validation and lineage is None:  # noqa: E501
            raise ValueError("Invalid value for `lineage`, must not be `None`")  # noqa: E501

        self._lineage = lineage

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComplianceRuleBreakdown):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ComplianceRuleBreakdown):
            return True

        return self.to_dict() != other.to_dict()
