# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.98
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class FxConventions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'fgn_ccy': 'str',
        'dom_ccy': 'str',
        'fixing_reference': 'str'
    }

    attribute_map = {
        'fgn_ccy': 'fgnCcy',
        'dom_ccy': 'domCcy',
        'fixing_reference': 'fixingReference'
    }

    required_map = {
        'fgn_ccy': 'required',
        'dom_ccy': 'required',
        'fixing_reference': 'required'
    }

    def __init__(self, fgn_ccy=None, dom_ccy=None, fixing_reference=None, local_vars_configuration=None):  # noqa: E501
        """FxConventions - a model defined in OpenAPI"
        
        :param fgn_ccy:  The foreign currency (required)
        :type fgn_ccy: str
        :param dom_ccy:  The domestic currency (required)
        :type dom_ccy: str
        :param fixing_reference:  The reference name used to find the desired quote (required)
        :type fixing_reference: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._fgn_ccy = None
        self._dom_ccy = None
        self._fixing_reference = None
        self.discriminator = None

        self.fgn_ccy = fgn_ccy
        self.dom_ccy = dom_ccy
        self.fixing_reference = fixing_reference

    @property
    def fgn_ccy(self):
        """Gets the fgn_ccy of this FxConventions.  # noqa: E501

        The foreign currency  # noqa: E501

        :return: The fgn_ccy of this FxConventions.  # noqa: E501
        :rtype: str
        """
        return self._fgn_ccy

    @fgn_ccy.setter
    def fgn_ccy(self, fgn_ccy):
        """Sets the fgn_ccy of this FxConventions.

        The foreign currency  # noqa: E501

        :param fgn_ccy: The fgn_ccy of this FxConventions.  # noqa: E501
        :type fgn_ccy: str
        """
        if self.local_vars_configuration.client_side_validation and fgn_ccy is None:  # noqa: E501
            raise ValueError("Invalid value for `fgn_ccy`, must not be `None`")  # noqa: E501

        self._fgn_ccy = fgn_ccy

    @property
    def dom_ccy(self):
        """Gets the dom_ccy of this FxConventions.  # noqa: E501

        The domestic currency  # noqa: E501

        :return: The dom_ccy of this FxConventions.  # noqa: E501
        :rtype: str
        """
        return self._dom_ccy

    @dom_ccy.setter
    def dom_ccy(self, dom_ccy):
        """Sets the dom_ccy of this FxConventions.

        The domestic currency  # noqa: E501

        :param dom_ccy: The dom_ccy of this FxConventions.  # noqa: E501
        :type dom_ccy: str
        """
        if self.local_vars_configuration.client_side_validation and dom_ccy is None:  # noqa: E501
            raise ValueError("Invalid value for `dom_ccy`, must not be `None`")  # noqa: E501

        self._dom_ccy = dom_ccy

    @property
    def fixing_reference(self):
        """Gets the fixing_reference of this FxConventions.  # noqa: E501

        The reference name used to find the desired quote  # noqa: E501

        :return: The fixing_reference of this FxConventions.  # noqa: E501
        :rtype: str
        """
        return self._fixing_reference

    @fixing_reference.setter
    def fixing_reference(self, fixing_reference):
        """Sets the fixing_reference of this FxConventions.

        The reference name used to find the desired quote  # noqa: E501

        :param fixing_reference: The fixing_reference of this FxConventions.  # noqa: E501
        :type fixing_reference: str
        """
        if self.local_vars_configuration.client_side_validation and fixing_reference is None:  # noqa: E501
            raise ValueError("Invalid value for `fixing_reference`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                fixing_reference is not None and len(fixing_reference) > 64):
            raise ValueError("Invalid value for `fixing_reference`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                fixing_reference is not None and len(fixing_reference) < 0):
            raise ValueError("Invalid value for `fixing_reference`, length must be greater than or equal to `0`")  # noqa: E501

        self._fixing_reference = fixing_reference

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FxConventions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FxConventions):
            return True

        return self.to_dict() != other.to_dict()
